import { DynamicModule, OnApplicationBootstrap } from '@nestjs/common';
import { Class, ForRootAsyncOptions, ForRootOptions, MongoModuleOptions } from '../lib/types';
import { MongoClient } from '../lib/mongodb';
export declare class MongoModule implements OnApplicationBootstrap {
    private readonly client?;
    constructor(client?: MongoClient | undefined);
    static forRoot(options: ForRootOptions<MongoModuleOptions>): DynamicModule;
    static forRootAsync({ inject, useFactory }: ForRootAsyncOptions<MongoModuleOptions>): DynamicModule;
    static forFeature(entities: Array<Class>): DynamicModule;
    private static getProviders;
    onApplicationBootstrap(): Promise<void>;
}
